// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "JSONLoader.hpp"
#include "scene/Scene.hpp"

namespace Dawn {
  class LoaderForSceneItems : public AssetLoader {
    protected:
      std::shared_ptr<JSONLoader> jsonLoader;
      struct SceneComponentLoadContext ctx;

      /**
       * Loads the dependencies into the context for the data available in
       * the jsonLoader.
       */
      void setupDependencies();

    public:
      LoaderForSceneItems(
        const std::shared_ptr<AssetManager> assetManager,
        const std::string name
      );

      ~LoaderForSceneItems();
  };
}